#! /usr/local/bin/perl
# APNIC Filter for PF

use Socket;
use Sys::Syslog;

# DEF File read
require '/usr/local/etc/c_filter.conf' ;

#foreach $country ( keys %{$WhiteLists} ) {
#
#	if ( $WhiteLists->{$country} eq 'true' ) {
#		$ADFlag{ $country } = 1 ;
#	}
#	else {
#		$ADFlag{ $country } = 0 ;
#	}
#}

openlog( 'C_Filter', 'pid', 'auth' ) ;

if ( open ( CF, "$CountryFile" ) ) {

#	false	: 0
#	true	: 1
#	None	: 2

	while( <CF> ) {

		( $CC, $FL, $TMP ) = split( /\t/, $_ ) ;

		if ( $FL eq 'true' ) {
			$ADFlag{ $CC } = "1" ;
		}
		elsif ( $FL eq 'false' ) {
			$ADFlag{ $CC } = "0" ;
		}
		else {
			$ADFlag{ $CC } = "2" ;
		}

	}

}
else {
	syslog( 'notice', "Can't filter table file $PFTableFile" ) ;
	exit ;
}


if ( open( TF, ">$PFTableFile" ) ) { 

	foreach $NIC ( %{$NICList} ) {

		if ( $NICList->{$NIC} == 1 ) {

			$FETCHFile = "$StatsListURL->{$NIC}" . "$ListFileName->{$NIC}" ;
			$DATAFile  = "$GetFileTMP" . "\/" . "$ListFileName->{$NIC}" ;

			if ( system( "fetch -o $GetFileTMP $FETCHFile" ) != 0 ) {
				syslog( 'notice', "Can't datafile download $NIC" ) ;
				next ;
			}
			else {

				if ( open( DF, "$DATAFile" ) ) {


					# file read and list make
					while ( <DF> ) {
						if (/^(\S+)\|(..)\|ipv4\|(\d+.\d+.\d+.\d)\|(\d+)/) {

							$country = $2 ;
							$ipaddr  = $3 ;
							$range   = $4 ;

							# BLACK
							if ( $EXECMode eq 'BLACK' ) {
								if ( $ADFlag{$country} eq "0" or ( $UndefMode eq 'block' and $ADFlag{$country} ne "1" ) ) {
									$table{inet_aton($ipaddr)} = $range ;
								}
							}
							# WHITE
							else {
								if ( $ADFlag{$country} eq "1" or ( $UndefMode eq 'pass' and $ADFlag{$country} ne "0" ) ) {
									$table{inet_aton($ipaddr)} = $range ;
								}
							}

						}
					}



					foreach $net ( sort keys %table ) {
						$addr = unpack( 'N' , $net ) ;
						$num = $table{$net} ;
						while ( $num == $num[0] && ( $addr ^ $addr[0] ) == $num ) {
							shift @addr ;
							shift @num ;
							$addr &= ~$num ;
							$num <<= 1 ;
						}
						unshift( @addr, $addr ) ;
						unshift( @num, $num ) ;
					}



					while ( @addr ) {
						for ($num = pop(@num), $mask = 32; $num > 1; $num >>= 1, $mask--) {}

						$filt = inet_ntoa(pack('N', pop(@addr))) . "/$mask";

						print TF "$filt\t\n";


					}

					close ( DF ) ;

				}
				else {

					syslog( 'notice', "Can't open datafile $NIC" ) ;

				}

			}

		}

	}

	close( TF ) ;

	if ( system( "$PFCTLCommand -t $PFTable -T replace -f $PFTableFile" ) == 0 ) {
		syslog( 'notice', "filter rules replace");
	}
	else {
		syslog( 'notice', "Couldn't filter rules update");
	}

}
else {
	syslog( 'notice', "Can't filter table file $PFTableFile" ) ;
	exit ;
}

closelog() ;

